#include <type_traits>
#include <iostream>
#include <vector>

template <typename T, typename Enable = void>
class Container {
public:
    void add(const T& value) {
        std::cout << "General container" << std::endl;
    }
};

template <typename T>
class Container<T, typename std::enable_if<std::is_arithmetic<T>::value>::type> {
public:
    void add(const T& value) {
        std::cout << "Arithmetic container" << std::endl;
    }
};

int main() {
    Container<std::string> c1;
    c1.add("Hello");

    Container<int> c2;
    c2.add(42);
}
